package it.amattioli.guidate.editing;

import java.util.ArrayList;

import it.amattioli.applicate.commands.ListEditor;
import it.amattioli.guidate.collections.PrototypeListItemRenderer;
import it.amattioli.guidate.containers.BackBeans;

import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.SelectEvent;
import org.zkoss.zk.ui.util.GenericComposer;
import org.zkoss.zul.Listbox;
import org.zkoss.zul.Listitem;

public class EditorListboxComposer extends GenericComposer {
    private ListEditor<?> editor;
    
    public void onCreate(Event evt) {
    	Listbox listbox = (Listbox)evt.getTarget();
    	this.editor = (ListEditor<?>)BackBeans.findBackBean(listbox);
    	ArrayList<Listitem> prototypes = new ArrayList<Listitem>();
    	for (int i = 0; i < listbox.getItemCount(); i++) {
	    	Listitem prototype = listbox.getItemAtIndex(i);
	    	prototype.detach();
	        prototypes.add(prototype);
    	}
        listbox.setItemRenderer(new PrototypeListItemRenderer(prototypes));
        listbox.setModel(new ListEditorModel(editor));
    }
    
    public void onSelect(SelectEvent evt) {
        for (Object curr:evt.getSelectedItems()) {
            editor.select(((Listitem)curr).getIndex());
        }
    }

}
