package it.amattioli.guidate.init;

import it.amattioli.applicate.sessions.ApplicateSession;
import it.amattioli.applicate.sessions.ServiceFactory;
import it.amattioli.guidate.config.GuidateConfig;

import org.zkoss.zk.ui.Session;
import org.zkoss.zk.ui.util.SessionCleanup;
import org.zkoss.zk.ui.util.SessionInit;

public class SessionInitAndCleanup implements SessionInit, SessionCleanup {
	public static final String ORDINI_SESSION = "it.maticasrl.ordini.session";

	@Override
	public void init(Session zkSession, Object request) throws Exception {
		if (!GuidateConfig.instance.isSessionInDesktop()) {
			ApplicateSession session = GuidateConfig.instance.getApplicateSessionClass().newInstance();
	    	ServiceFactory serviceFactory = GuidateConfig.instance.getServiceFactoryClass().newInstance();
	    	session.setServiceFactory(serviceFactory);
	        zkSession.setAttribute(ORDINI_SESSION, session);
		}
	}

	@Override
	public void cleanup(Session zkSession) throws Exception {
		if (!GuidateConfig.instance.isSessionInDesktop()) {
			((ApplicateSession)zkSession.getAttribute(ORDINI_SESSION)).release();
			zkSession.setAttribute(ORDINI_SESSION, null);
		}
	}

}
